############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXNODE, NX protocol compression and NX extensions to this software      #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package Common::NXProcess;no warnings;($NXProcess::children={});(
$NXProcess::childrenData={});($NXProcess::finishedChildren={});(
$NXProcess::childFinishedWithSignal={});($NXProcess::childrenExitCallback={});(
$NXProcess::childrenErrorCallback={});($NXProcess::childrenToLeave={});(
$NXProcess::watchDogList={});($NXProcess::finishedWatchDogList={});(
$NXProcess::watchDogToLeaveList={});($NXProcess::watchDogAsSuperuser={});(
$NXProcess::errorNoProcessToWait=(-(0x060c+ 7070-0x21a9)));(
$NXProcess::statusRunning=(0x1fec+ 677-0x2291));($NXProcess::statusExited=
(0x02bf+ 7797-0x2133));($NXProcess::signalKill=(0x0d86+ 1102-0x11cb));(
$NXProcess::signalTerm=(0x07d0+ 1227-0x0c8c));($NXProcess::signalSegv=
(0x060c+ 7965-0x251e));($NXProcess::processTree=(0x1a36+ 1572-0x2059));(
$NXProcess::noProcessTree=(0x1400+ 3480-0x2198));sub nxProcessCreate{(my $filename
=shift (@_));(my $command=shift (@_));(my $environment=shift (@_));(my $stdin=
shift (@_));(my $stdout=shift (@_));(my $stderr=shift (@_));(my $priority=shift 
(@_));my ($pid);my ($pidOrHandle);Logger::debug (((((((((((((((
"\x6e\x78\x50\x72\x6f\x63\x65\x73\x73\x43\x72\x65\x61\x74\x65\x3a\x20\x27".
$filename)."\x27\x20\x27").join ($",@$command))."\x27\x20\x27").join ($",
@$environment))."\x27\x20\x27\x46\x44\x23").$stdin)."\x27\x20\x27\x46\x44\x23").
$stdout)."\x27\x20\x27\x46\x44\x23").$stderr)."\x27\x20\x27").$priority)."\x27")
);($pidOrHandle=libnxh::NXProcessCreate ($filename,$command,$environment,$stdin,
$stdout,$stderr,$priority));if (($pidOrHandle==(-(0x0d26+ 2131-0x1578)))){
Common::NXCore::reportErrorFromNXPL (((((((((((((((((
"\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x43\x72\x65\x61\x74\x65\x28".$filename).
"\x2c\x20").$command)."\x2c\x20").$environment)."\x2c\x20").$stdin)."\x2c\x20").
$stdout)."\x2c\x20").$stderr)."\x2c\x20").$priority).
"\x29\x20\x66\x61\x69\x6c\x65\x64\x20\x77\x69\x74\x68\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20"
).$pidOrHandle)."\x2e"));return ((-(0x0835+ 1006-0x0c22)));}($pid=
handleProcessHandle ($pidOrHandle));addChild ($pid);(my $commandLine=$filename);
foreach my $parameter (@$command){if (($parameter eq $filename)){next;}else{(
$commandLine.=("\x20".$parameter));}}registerChildName ($commandLine,$pid);
return ($pid);}sub nxProcessExec{(my $filename=shift (@_));(my $command=shift (
@_));(my $environment=shift (@_));(my $ref_error=shift (@_));Logger::debug (((((
(("\x6e\x78\x50\x72\x6f\x63\x65\x73\x73\x45\x78\x65\x63\x3a\x20\x27".$filename).
"\x27\x20\x27").join ($",@$command))."\x27\x20\x27").join ($",@$environment)).
"\x27"));(my $result=libnxh::NXProcessExec ($filename,$command,$environment));if
 (($result==(-(0x08b7+ 1567-0x0ed5)))){Common::NXCore::reportErrorFromNXPL (((((
(((("\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x45\x78\x65\x63\x28".$filename).
"\x2c\x20").$command)."\x2c\x20").$environment).
"\x29\x20\x66\x61\x69\x6c\x65\x64\x20\x77\x69\x74\x68\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20"
).$result)."\x2e"));($$ref_error=libnxh::NXGetErrorString ());return (
(0x0586+ 179-0x0639));}return ((0x0a15+ 5467-0x1f6f));}sub handleProcessHandle{(my $pidOrHandle
=shift (@_));return ($pidOrHandle);(my $pid=getPidFromHandle ($pidOrHandle));(
$NXProcess::processPidsArrayByHandle{$pidOrHandle}=$pid);(
$NXProcess::processHandlesArrayByPid{$pid}=$pidOrHandle);return ($pid);}sub 
getPidFromHandle{(my $handle=shift (@_));(my $pid=libnxh::NXConvertHandlerToPid 
($handle));Logger::debug (((((
"\x67\x65\x74\x50\x69\x64\x46\x72\x6f\x6d\x48\x61\x6e\x64\x6c\x65\x3a\x20\x68\x61\x6e\x64\x6c\x65\x20\x5b"
.$handle).
"\x5d\x20\x63\x6f\x6e\x76\x65\x72\x74\x65\x64\x20\x74\x6f\x20\x70\x69\x64\x20\x5b"
).$pid)."\x5d\x2e"));return ($pid);}sub convertToHandleIfNeeded{(my $pid=shift (
@_));return ($pid);if (defined ($NXProcess::processHandlesArrayByPid{$pid})){(my $handle
=$NXProcess::processHandlesArrayByPid{$pid});if (($pid==
$NXProcess::processPidsArrayByHandle{$handle})){return ($handle);}}return ($pid)
;}sub checkIsProcessFinished{(my $pid=shift (@_));if (($pid>
(0x0571+ 3896-0x14a9))){if ((not (isChildProcess ($pid)))){if (isChildFinished (
$pid)){return ((0x0054+ 384-0x01d3));}if ((not (isOnWatchdogProcess ($pid)))){if
 (isFinishedWatchDog ($pid)){return ((0x01f3+ 1145-0x066b));}return ((-
(0x0b9a+ 4874-0x1ea3)));}}}if (($pid==(0x2301+ 303-0x2430))){return ((-
(0x239d+ 429-0x2549)));}return ((0x02fd+ 5190-0x1743));}sub 
checkForWaitingEventForPid{(my $pid=shift (@_));(my $childrenList=
$NXProcess::children);if (($pid==(-(0x1011+ 2824-0x1b18)))){foreach my $listpid 
(keys (%$childrenList)){if (isChildFinished ($listpid)){return ($listpid);}else{
next;}}return ((0x013a+ 3903-0x1079));}elsif (($pid>(0x0514+ 2450-0x0ea6))){if (
isChildProcess ($pid)){if (isChildFinished ($pid)){return ($pid);}else{return (
(0x15a3+ 782-0x18b1));}}else{if (isChildFinished ($pid)){return ($pid);}if (
isFinishedWatchDog ($pid)){return ($pid);}if (isOnWatchdogProcess ($pid)){return
 ((0x0238+ 862-0x0596));}return ((-(0x050c+ 506-0x0705)));}}return ((-
(0x0047+ 4854-0x133c)));}sub nxwaitpid{(my $pid=shift (@_));(my $options=(shift 
(@_)||$NXBits::WAIT_NOHANG));(my $timeout=(shift (@_)||"\x69\x6e\x66"));(my $startwaitpid
=Common::NXTime::getSecondsSinceEpoch ());(my $sigpid=(-(0x0566+ 5072-0x1935)));my (
$status);my ($nxplreturn);(my $finished=checkIsProcessFinished ($pid));if ((
$finished!=(0x122b+ 1083-0x1666))){if (($finished==(-(0x016b+ 199-0x0231)))){
return ((-(0x00d5+ 8924-0x23b0)));}return ($pid);}(my $selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;(my $signalFd=$$NXBegin::parser{"\x53\x69\x67\x6e\x61\x6c"});$selector->add (
$signalFd);if (($options==$NXBits::WAIT_UNTRACED)){while ((0x0d08+ 1835-0x1432))
{if (($timeout eq "\x69\x6e\x66")){Common::NXCore::exitFromSelectOnFirstSignal 
();(my (@ready)=$selector->can_read);
Common::NXCore::disableExitFromSelectOnFirstSignal ();}else{if (($timeout<=
(0x0904+ 3918-0x1852))){return ((0x1991+ 1443-0x1f34));}
Common::NXCore::exitFromSelectOnFirstSignal ();(my (@ready)=$selector->can_read 
(($timeout *(0x155a+ 3018-0x1d3c))));
Common::NXCore::disableExitFromSelectOnFirstSignal ();($timeout=($timeout-(
Common::NXTime::getSecondsSinceEpoch ()-$startwaitpid)));}(my $check=
checkForWaitingEventForPid ($pid));if (((!$check)==(0x1f61+ 1373-0x24be))){
return ($check);}}}else{(my (@ready)=$selector->can_read ((0x03f6+ 7256-0x204e),
"\x73\x69\x6c\x65\x6e\x74"));(my $waitingEvent=checkForWaitingEventForPid ($pid)
);return ($waitingEvent);}}sub nxChildProcessCheck{(my $pid=shift (@_));(my $status
=(0x0293+ 8232-0x22bb));(my $exit=(0x1b20+ 1713-0x21d1));my ($nxplreturn);(my $pidToNxpl
=convertToHandleIfNeeded ($pid));($nxplreturn=libnxh::NXProcessCheck ($pidToNxpl
,$status));if (($nxplreturn==(-(0x0501+ 813-0x082d)))){(my $errname=
libnxh::NXGetErrorName ());Logger::warning (((((((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x28".$pid)
."\x2f").$pidToNxpl).
"\x29\x20\x77\x69\x74\x68\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x43\x68\x65\x63\x6b\x20\x66\x61\x69\x6c\x65\x64\x20\x77\x69\x74\x68\x20\x65\x72\x72\x6f\x72\x20\x27"
).$errname)."\x27\x2e"));}sub BEGIN{require POSIX;do{"\x50\x4f\x53\x49\x58"->
import ("\x3a\x73\x79\x73\x5f\x77\x61\x69\x74\x5f\x68")};}if (($nxplreturn==
(0x02b9+ 4785-0x156a))){if (WIFEXITED ($status)){($exit=WEXITSTATUS ($status));
setChildExitCode ($pid,$exit);}if (WIFSIGNALED ($status)){($exit=WTERMSIG (
$status));setChildExitSignal ($pid,$exit);}}return ($nxplreturn);}sub sigterm{(my $process_pid
=shift (@_));if (libnxh::NXProcessRunning ($process_pid)){my ($result);if (
isChildProcess ($process_pid)){Logger::debug (((
"\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x54\x45\x52\x4d\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($result=libnxh::NXProcessKill ($process_pid,$NXBITS::SIGTERM));}else{
Logger::debug (((
"\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x54\x45\x52\x4d\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x6e\x6f\x74\x20\x61\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($result=libnxh::NXKillProcess ($process_pid,$NXBITS::SIGTERM));}if (($result
==(-(0x0895+ 7271-0x24fb)))){Common::NXCore::reportErrorFromNXPL (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x54\x45\x52\x4d\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid)."\x2e"));return ((0x12df+ 4161-0x2320));}else{Logger::debug (((((
"\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x54\x45\x52\x4d\x20\x72\x65\x74\x75\x72\x6e\x65\x64\x20"
).$result)."\x2e"));return ((0x07ff+ 1283-0x0d01));}}Logger::debug (((
"\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x54\x45\x52\x4d\x2c\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
));return ((0x07bf+ 4836-0x1aa2));}sub winKillTreeProcess{return (
(0x0491+ 1928-0x0c18));}sub sigkill{(my $process_pid=shift (@_));(my $process_tree
=(shift (@_)||(0x147d+ 636-0x16f9)));if ((not (defined ($process_pid)))){
Logger::warning (
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x62\x75\x74\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x70\x69\x64\x20\x69\x73\x20\x65\x6d\x70\x74\x79\x2e"
);return ((0x24b6+ 356-0x261a));}if ((($process_pid==(0x0994+ 2683-0x140f))or (
$process_pid==$ $))) {
 main::nxexit (getSignalKill ());}(my $pidToNxpl=
convertToHandleIfNeeded ($process_pid));(my $status=isProcessRunning (
$process_pid));if ($status){my ($return);if (isChildProcess ($process_pid)){
Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($return=libnxh::NXProcessKill ($pidToNxpl,getSignalKill ()));}else{if ((
$process_tree==(0x0f30+ 883-0x12a3))){Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x6e\x6f\x74\x20\x61\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($return=libnxh::NXKillProcess ($process_pid,getSignalKill ()));}else{
Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x74\x72\x65\x65\x2e"
));($return=libnxh::NXKillTree ($process_pid,getSignalKill ()));}}if (($return==
(-(0x018d+ 254-0x028a)))){Common::NXCore::reportErrorFromNXPL (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid)."\x2e"));return ((0x145b+ 3021-0x2028));}else{Logger::debug (((((
(("\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".
$process_pid)."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x72\x65\x74\x75\x72\x6e\x65\x64\x20"
).$return)."\x2e"));return ((0x0714+ 1806-0x0e21));}}else{Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x2c\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
));}return ((0x1351+ 806-0x1676));}sub sigSegv{(my $process_pid=shift (@_));if (
(not (defined ($process_pid)))){Logger::warning (
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x53\x45\x47\x56\x20\x62\x75\x74\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x70\x69\x64\x20\x69\x73\x20\x65\x6d\x70\x74\x79\x2e"
);return ((0x050f+ 5137-0x1920));}(my $pidToNxpl=convertToHandleIfNeeded (
$process_pid));(my $status=isProcessRunning ($process_pid));if ($status){my (
$return);if (isChildProcess ($process_pid)){Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x53\x45\x47\x56\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($return=libnxh::NXProcessKill ($pidToNxpl,getSignalSegv ()));}else{
Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x53\x45\x47\x56\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x6e\x6f\x74\x20\x61\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($return=libnxh::NXKillProcess ($process_pid,getSignalSegv ()));}if (($return
==(-(0x1105+ 5641-0x270d)))){Common::NXCore::reportErrorFromNXPL (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x53\x45\x47\x56\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid)."\x2e"));return ((0x221a+ 721-0x24eb));}else{Logger::debug ((((((
("\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid
)."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x53\x45\x47\x56\x20\x72\x65\x74\x75\x72\x6e\x65\x64\x20"
).$return)."\x2e"));return ((0x15cc+ 1151-0x1a4a));}}else{Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x53\x45\x47\x56\x2c\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
));}return ((0x074d+ 1378-0x0cae));}sub signalProcessByRestrictedScript{(my $pid
=shift (@_));(my $signal=shift (@_));(my $tree=shift (@_));(my $nxkillScript=
"\x6e\x78\x6b\x69\x6c\x6c\x2e\x73\x68");(my (@command)=(
Common::NXCore::getNXExecCommand (),$nxkillScript,$pid,$signal,$tree));(my (
@parameters)=());main::run_command ((\@command),(\@parameters));}sub 
sendTerminateWaitAndKill{(my $processPid=shift (@_));(my $sleepTime=(shift (@_)
||(0x13d3+ 953-0x178b)));if ((($processPid==(0x05cf+ 142-0x065d))or (not (
defined ($processPid))))){Logger::debug (((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x70\x69\x64\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x27"
.$processPid)."\x27\x2e"));return ((0x0596+ 5192-0x19de));}if (isProcessRunning 
($processPid)){Logger::debug (((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x63\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$processPid).
"\x27\x20\x77\x69\x74\x68\x20\x73\x69\x67\x6e\x61\x6c\x20\x27\x31\x35\x27"));if 
(sigterm ($processPid)){Logger::debug (((
"\x53\x49\x47\x54\x45\x52\x4d\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x63\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));nxwaitpid ($processPid,$NXBits::WAIT_UNTRACED,$sleepTime)
;if (isProcessRunning ($processPid)){if (sigkill ($processPid)){Logger::debug ((
(
"\x53\x49\x47\x4b\x49\x4c\x4c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));}else{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));}}else{Logger::debug (((
"\x43\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$processPid).
"\x27\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x6f\x70\x70\x65\x64\x2e"
));}}else{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x54\x45\x52\x4d\x20\x74\x6f\x20\x63\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));}}else{Logger::debug (((
"\x43\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$processPid).
"\x27\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x6f\x70\x70\x65\x64\x2e"
));}}sub leaveOrphans{foreach my $pid (keys (%$NXProcess::childrenToLeave)){(my $pidToNxpl
=convertToHandleIfNeeded ($pid));(my $result=libnxh::NXForceRemove ($pidToNxpl))
;if (($result==(-(0x06f1+ 5684-0x1d24)))){Common::NXCore::reportErrorFromNXPL ((
(((
"\x43\x61\x6e\x6e\x6f\x74\x20\x66\x6f\x72\x63\x65\x20\x72\x65\x6d\x6f\x76\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$pid)."\x2f").$pidToNxpl)."\x2e"));}else{Logger::debug (((((
"\x4c\x65\x66\x74\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$pid)."\x2f").$pidToNxpl)
."\x20\x61\x73\x20\x6f\x72\x70\x68\x61\x6e\x2e"));}}foreach my $pid (keys (
%$NXProcess::watchDogList)){(my $result=libnxh::NXRemoveWatchdog ($pid));if ((
$result==(-(0x1854+ 380-0x19cf)))){Common::NXCore::reportErrorFromNXPL (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x77\x61\x74\x63\x68\x64\x6f\x67\x20\x6f\x6e\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$pid)."\x2e"));}else{Logger::debug (((((
"\x52\x65\x6d\x6f\x76\x65\x64\x20\x77\x61\x74\x63\x68\x64\x6f\x67\x20\x6f\x6e\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$pid)."\x20\x77\x69\x74\x68\x20\x72\x65\x73\x75\x6c\x74\x20\x27").$result).
"\x27\x2e"));}}}sub leaveChildAtFinish{(my $pid=shift (@_));if (isChildProcess (
$pid)){Logger::debug (((
"\x53\x65\x74\x74\x69\x6e\x67\x20\x63\x68\x69\x6c\x64\x20".$pid).
"\x20\x74\x6f\x20\x62\x65\x20\x6c\x65\x66\x74\x20\x61\x66\x74\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x65\x6e\x64\x73\x2e"
));($$NXProcess::childrenToLeave{$pid}=(0x0595+ 3356-0x12b0));}}sub 
leaveWatchdogAtFinish{(my $pid=shift (@_));($$NXProcess::watchDogToLeaveList{
$pid}=(0x14e3+ 1003-0x18cd));}sub removeFromLeaveWatchdogAtFinishList{(my $pid=
shift (@_));delete ($$NXProcess::watchDogToLeaveList{$pid});}sub 
addToWatchDogList{(my $pid=shift (@_));($$NXProcess::watchDogList{$pid}=
(0x2082+ 167-0x2128));delete ($$NXProcess::finishedWatchDogList{$pid});}sub 
handleWatchDogSIG{foreach my $pid (keys (%$NXProcess::watchDogList)){
Logger::debug3 (((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x6e\x6f\x74\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27"
.$pid)."\x27\x2e"));if ((not (libnxh::NXProcessRunning ($pid)))){Logger::debug (
(("\x4e\x6f\x74\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27"
.$pid)."\x27\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"));
(my $callback=$$NXProcess::childrenExitCallback{$pid});Logger::debug (((((
"\x45\x78\x65\x63\x75\x74\x69\x6e\x67\x20\x63\x61\x6c\x6c\x62\x61\x63\x6b\x20\x27"
.$callback)."\x27\x20\x66\x6f\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27").$pid
)."\x2e\x27"));delete ($$NXProcess::watchDogList{$pid});libnxh::NXRemoveWatchdog
 ($pid);($$NXProcess::finishedWatchDogList{$pid}=(0x04f5+ 345-0x064d));if ((
$callback ne (""))){&{$callback;}($pid,(0x041c+ 3481-0x11b5));}}}}sub 
setCallbackSIGCHLD{(my $pid=shift (@_));(my $callback=shift (@_));(
$$NXProcess::childrenExitCallback{$pid}=$callback);(
$$NXProcess::childrenErrorCallback{$pid}=$callback);if (((not (isChildProcess (
$pid)))and (not (isOnWatchdogProcess ($pid))))){addToWatchDogList ($pid);}
Logger::debug2 ((((("\x4e\x65\x77\x20\x63\x61\x6c\x6c\x62\x61\x63\x6b\x20\x5b".
$$NXProcess::childrenExitCallback{$pid}).
"\x5d\x20\x66\x6f\x72\x20\x53\x49\x47\x43\x48\x49\x4c\x44\x20\x66\x6f\x72\x20\x70\x69\x64\x20\x5b"
).$pid)."\x5d"));}sub setExitCallback{(my $pid=shift (@_));(my $callback=shift (
@_));($$NXProcess::childrenExitCallback{$pid}=$callback);}sub setErrorCallback{(my $pid
=shift (@_));(my $callback=shift (@_));($$NXProcess::childrenErrorCallback{$pid}
=$callback);}sub addWatchdog{(my $pid=shift (@_));if (((not (defined ($pid)))or 
($pid==(0x11b2+ 505-0x13ab)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x61\x64\x64\x20\x77\x61\x74\x63\x68\x64\x6f\x67\x20\x66\x6f\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x50\x49\x44\x20\x27"
.$pid)."\x27\x2e"));return ((-(0x1508+ 4526-0x26b5)));}if (isOnWatchdogProcess (
$pid)){Logger::warning ((("\x50\x72\x6f\x63\x65\x73\x73\x20\x50\x49\x44\x20\x27"
.$pid).
"\x27\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x6f\x6e\x20\x77\x61\x74\x63\x68\x64\x6f\x67\x20\x6c\x69\x73\x74\x2e"
));return ((0x17ba+ 1344-0x1cfa));}Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x41\x64\x64\x57\x61\x74\x63\x68\x64\x6f\x67\x28"
.$pid)."\x2c\x20").$NXBITS::SIGCHLD)."\x29\x2e"));(my $result=
libnxh::NXAddWatchdog ($pid,$NXBITS::SIGCHLD));Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x41\x64\x64\x57\x61\x74\x63\x68\x64\x6f\x67\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$result)."\x27\x2e"));addToWatchDogList ($pid);setCallbackSIGCHLD ($pid,(
\&nxDefaultWatchdogExitHandler));return ((0x0483+ 6877-0x1f60));}sub addChild{(my $pid
=(shift (@_)||(0x0376+ 4687-0x15c5)));if (($pid<=(0x0c83+ 3816-0x1b6b))){
Logger::warning (((
"\x54\x72\x79\x69\x6e\x67\x20\x74\x6f\x20\x61\x64\x64\x20\x77\x72\x6f\x6e\x67\x20\x70\x69\x64\x20\x27"
.$pid)."\x27\x2e"));return;}if ((not (isChildProcess ($pid)))){(my $pidToNxpl=
convertToHandleIfNeeded ($pid));(my $nxplreturn=libnxh::NXProcessAdd ($pidToNxpl
));($$NXProcess::children{$pid}=(0x008f+ 100-0x00f2));Logger::debug (((((
"\x41\x64\x64\x65\x64\x20\x27".$pid)."\x2f").$pidToNxpl).
"\x27\x20\x74\x6f\x20\x63\x68\x69\x6c\x64\x72\x65\x6e\x20\x6c\x69\x73\x74\x2e"))
;($$NXProcess::childrenExitCallback{$pid}=(\&nxDefaultExitCodeHandler));(
$$NXProcess::childrenErrorCallback{$pid}=(\&nxDefaultExitCodeHandler));(
$$NXProcess::childFinishedWithSignal{$pid}=(0x05b4+ 2350-0x0ee2));if (
isChildFinished ($pid)){delete ($$NXProcess::finishedChildren{$pid});}if (
isFinishedWatchDog ($pid)){delete ($$NXProcess::finishedWatchDogList{$pid});}}
else{Logger::debug (((
"\x54\x72\x79\x69\x6e\x67\x20\x74\x6f\x20\x61\x64\x64\x20\x73\x61\x6d\x65\x20\x70\x69\x64\x20\x27"
.$pid)."\x27\x20\x61\x73\x20\x63\x68\x69\x6c\x64\x2e"));}}sub 
nxDefaultExitCodeHandler{(my $pid=shift (@_));(my $code=shift (@_));
Logger::debug (((
"\x6e\x78\x44\x65\x66\x61\x75\x6c\x74\x45\x78\x69\x74\x43\x6f\x64\x65\x48\x61\x6e\x64\x6c\x65\x72\x3a\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$pid)."\x20\x6a\x75\x73\x74\x20\x64\x69\x65\x64\x2e"));}sub 
nxDefaultWatchdogExitHandler{(my $pid=shift (@_));Logger::debug (((
"\x6e\x78\x44\x65\x66\x61\x75\x6c\x74\x57\x61\x74\x63\x68\x64\x6f\x67\x45\x78\x69\x74\x48\x61\x6e\x64\x6c\x65\x72\x3a\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x5b"
.$pid)."\x5d\x20\x6a\x75\x73\x74\x20\x64\x69\x65\x64\x2e"));}sub removechild{(my $pid
=shift (@_));if (isChildProcess ($pid)){Logger::debug (((
"\x47\x6f\x69\x6e\x67\x20\x74\x6f\x20\x63\x61\x6c\x6c\x20\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x52\x65\x6d\x6f\x76\x65\x28"
.$pid)."\x29"));(my $pidToNxpl=convertToHandleIfNeeded ($pid));(my $nxplreturn=
libnxh::NXProcessRemove ($pidToNxpl));if (($nxplreturn==(-(0x0d62+ 3261-0x1a1e))
)){Common::NXCore::reportErrorFromNXPL (((
"\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x52\x65\x6d\x6f\x76\x65\x28".$pidToNxpl).
"\x29\x20\x66\x61\x69\x6c\x65\x64\x2e"));}(my ($name,$lifetime)=
getChildNameAndLifetime ($pid));if (processTerminatedBySignal ($pid)){(my $exitSignal
=getChildExitSignal ($pid));if (($exitSignal!=$NXBITS::SIGTERM)){Logger::warning
 ((((((((((("\x50\x72\x6f\x63\x65\x73\x73\x20\x27".$name).
"\x27\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27").$pid)."\x2f").$pidToNxpl).
"\x27\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x77\x69\x74\x68\x20\x73\x69\x67\x6e\x61\x6c\x20"
).$exitSignal)."\x20\x61\x66\x74\x65\x72\x20").$lifetime).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));}else{Logger::debug (((((((((((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x27".$name).
"\x27\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27").$pid)."\x2f").$pidToNxpl).
"\x27\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x77\x69\x74\x68\x20\x73\x69\x67\x6e\x61\x6c\x20"
).$exitSignal)."\x20\x61\x66\x74\x65\x72\x20").$lifetime).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));}}else{(my $exitCode=getChildExitCode (
$pid));if (($exitCode==(0x1d3b+ 1643-0x23a6))){Logger::debug (((((((((((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x27".$name).
"\x27\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27").$pid)."\x2f").$pidToNxpl).
"\x27\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x77\x69\x74\x68\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20"
).$exitCode)."\x20\x61\x66\x74\x65\x72\x20").$lifetime).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));}else{Logger::warning (((((((((((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x27".$name).
"\x27\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27").$pid)."\x2f").$pidToNxpl).
"\x27\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x77\x69\x74\x68\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20"
).$exitCode)."\x20\x61\x66\x74\x65\x72\x20").$lifetime).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));}}delete ($$NXProcess::children{$pid});
}if (exists ($$NXProcess::childrenToLeave{$pid})){delete (
$$NXProcess::childrenToLeave{$pid});}}sub isProcessRunning{(my $pid=shift (@_));
if (((not (defined ($pid)))or ($pid<=(0x06b3+ 2058-0x0ebd)))){return (
(0x110d+ 1316-0x1631));}if (($pid==$ $)) {
 return ((0x0011+ 5084-0x13ec));}if (
isChildProcess ($pid)){return ((0x0480+ 8776-0x26c7));}(my $pidToNxpl=
convertToHandleIfNeeded ($pid));(my $ret=libnxh::NXProcessRunning ($pidToNxpl));
if (($ret==(-(0x0bf8+ 538-0x0e11)))){(my $errname=libnxh::NXGetErrorName ());if 
((($errname eq "\x45\x41\x43\x43\x45\x53")or ($errname eq "\x45\x50\x45\x52\x4d"
))){return ((0x1561+ 4465-0x26d1));}Logger::warning ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x68\x65\x63\x6b\x20\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x52\x75\x6e\x6e\x69\x6e\x67\x28"
.$pid)."\x2f").$pidToNxpl)."\x29\x20\x3a\x20").$errname));return (
(0x01c6+ 3148-0x0e12));}return ($ret);}sub handleSIGUSR1{Logger::debug (
"\x68\x61\x6e\x64\x6c\x65\x53\x49\x47\x55\x53\x52\x31",(0x1a5f+ 3005-0x261c));if
 (defined ($NXBegin::handlerSIGUSR1)){if (($NXBegin::handlerSIGUSR1 ne (""))){
Logger::debug (("\x47\x6f\x69\x6e\x67\x20\x74\x6f\x20\x63\x61\x6c\x6c\x3a\x20".
$NXBegin::handlerSIGUSR1),(0x01ca+ 4359-0x12d1));&$NXBegin::handlerSIGUSR1 ();}}
else{Logger::debug ("\x49\x67\x6e\x6f\x72\x69\x6e\x67\x20\x55\x53\x52\x31",
(0x1bec+ 1475-0x21af));}}sub handleSIGCHLD{(my $children=$NXProcess::children);my (
$status);my ($nxplreturn);foreach my $listpid (keys (%$children)){Logger::debug3
 ((
"\x68\x61\x6e\x64\x6c\x65\x53\x49\x47\x43\x48\x4c\x44\x20\x63\x68\x65\x63\x6b\x69\x6e\x67\x20\x63\x68\x69\x6c\x64\x3a\x20"
.$listpid),(0x0198+ 4843-0x1483));($nxplreturn=nxChildProcessCheck ($listpid));
unless ($nxplreturn){removechild ($listpid);my ($callback);if ((
$$NXProcess::finishedChildren{$listpid}==(0x1079+ 3866-0x1f93))){($callback=
$$NXProcess::childrenExitCallback{$listpid});}else{($callback=
$$NXProcess::childrenErrorCallback{$listpid});}&{$callback;}($listpid,
$$NXProcess::finishedChildren{$listpid});}}handleWatchDogSIG ();
handleWatchdogAsSuperuserSIGCHLD ();}sub getExitValue{(my $pid=shift (@_));(my $exitValue
=$$NXProcess::finishedChildren{$pid});if ((not (defined ($exitValue)))){if ((not
 (isChildProcess ($pid)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20\x66\x72\x6f\x6d\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$pid).
"\x2e\x20\x54\x68\x69\x73\x20\x69\x73\x20\x6e\x6f\x74\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));return ((0x0339+ 3023-0x0f08));}else{Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20\x66\x72\x6f\x6d\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$pid).
"\x2e\x20\x50\x72\x6f\x63\x65\x73\x73\x20\x73\x74\x69\x6c\x6c\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
));return ((0x1190+ 4010-0x213a));}}return ($exitValue);}sub isChildProcess{(my $pid
=shift (@_));if (exists ($$NXProcess::children{$pid})){return (
(0x0756+ 4026-0x170f));}else{return ((0x0616+ 4204-0x1682));}}sub 
isOnWatchdogProcess{(my $pid=shift (@_));if (exists ($$NXProcess::watchDogList{
$pid})){return ((0x19b8+ 2108-0x21f3));}else{return ((0x006f+ 3589-0x0e74));}}
sub isChildFinished{(my $pid=shift (@_));if (exists (
$$NXProcess::finishedChildren{$pid})){return ((0x040d+ 4593-0x15fd));}else{
return ((0x13c2+  99-0x1425));}}sub isFinishedWatchDog{(my $pid=shift (@_));if (
exists ($$NXProcess::finishedWatchDogList{$pid})){return ((0x0ca5+ 2774-0x177a))
;}else{return ((0x068a+ 6696-0x20b2));}}sub processTerminatedBySignal{(my $pid=
shift (@_));if (($$NXProcess::childFinishedWithSignal{$pid}==
(0x0de2+ 2811-0x18dc))){return ((0x03d4+ 909-0x0760));}else{return (
(0x18f7+ 3009-0x24b8));}}sub waitProcess{(my $pid=shift (@_));(my $timeout=shift
 (@_));my ($exitValue);my ($waitpidOption);my ($waitpidResult);my ($return);if (
($timeout gt (0x0594+ 6707-0x1fc7))){($waitpidOption=$NXBits::WAIT_UNTRACED);
Logger::debug (((((
"\x77\x61\x69\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x3a\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$pid)."\x27\x20\x75\x73\x69\x6e\x67\x20").$timeout).
"\x73\x20\x61\x73\x20\x74\x69\x6d\x65\x6f\x75\x74"));}else{($waitpidOption=
$NXBits::WAIT_NOHANG);Logger::debug (((
"\x77\x61\x69\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x3a\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$pid)."\x27"));}unless ((isChildProcess ($pid)or isOnWatchdogProcess ($pid))){
Logger::debug (((
"\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x3a\x20"
.$pid).
"\x20\x6e\x6f\x74\x20\x6d\x6f\x6e\x69\x74\x6f\x72\x65\x64\x2c\x20\x61\x64\x64\x69\x6e\x67\x20\x77\x61\x74\x63\x68\x64\x6f\x67\x2e"
));addWatchdog ($pid);}($waitpidResult=nxwaitpid ($pid,$waitpidOption,$timeout))
;if (($waitpidResult==$pid)){($exitValue=getStatusExited ());}elsif ((
$waitpidResult==(0x0027+ 7294-0x1ca5))){Logger::debug (((
"\x72\x65\x61\x63\x68\x65\x64\x20\x74\x69\x6d\x65\x6f\x75\x74\x20\x6f\x66\x20".
$timeout).((
"\x73\x20\x77\x68\x69\x6c\x65\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27"
.$pid)."\x27")));($exitValue=getStatusRunning ());}elsif (($waitpidResult==(-
(0x2015+ 924-0x23b0)))){Logger::debug (((
"\x6e\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x3a\x20\x27"
.$pid)."\x27\x20\x74\x6f\x20\x77\x61\x69\x74"));($exitValue=
getErrorNoProcessToWait ());}return ($exitValue);}sub getErrorNoProcessToWait{
return ($NXProcess::errorNoProcessToWait);}sub getStatusRunning{return (
$NXProcess::statusRunning);}sub getStatusExited{return ($NXProcess::statusExited
);}sub getSignalKill{return ($NXProcess::signalKill);}sub getSignalTerm{return (
$NXProcess::signalTerm);}sub getSignalSegv{return ($NXProcess::signalSegv);}sub 
getProcessTree{return ($NXProcess::processTree);}sub getNoProcessTree{return (
$NXProcess::noProcessTree);}sub registerChildName{(my $processName=shift (@_));(my $processPid
=shift (@_));(my ($sec,$microsec)=
Common::NXTime::getSecondsAndMicrosecondsSinceEpoch ());(my $milisec=sprintf (
"\x25\x30\x36\x64",$microsec));($milisec=substr ($milisec,(0x0013+ 6630-0x19f9),
(0x1055+ 3203-0x1cd5)));Logger::debug2 (((((((((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x27".$processName).
"\x27\x20\x73\x74\x61\x72\x74\x65\x64\x20\x77\x69\x74\x68\x20\x70\x69\x64\x3a\x20\x27"
).$processPid).
"\x27\x20\x61\x74\x20\x74\x69\x6d\x65\x73\x74\x61\x6d\x70\x20\x27").$sec)."\x2c"
).$milisec)."\x27"));($$NXProcess::childrenData{$processPid}={});(
$$NXProcess::childrenData{$processPid}{"\x6e\x61\x6d\x65"}=$processName);(
$$NXProcess::childrenData{$processPid}{
"\x73\x74\x61\x72\x74\x53\x65\x63\x6f\x6e\x64\x73"}=$sec);(
$$NXProcess::childrenData{$processPid}{
"\x73\x74\x61\x72\x74\x4d\x69\x6c\x69\x73\x65\x63\x6f\x6e\x64\x73"}=$milisec);}
sub getChildNameAndLifetime{(my $pid=shift (@_));(my $childData=
$$NXProcess::childrenData{$pid});if (defined ($childData)){(my $name=$$childData
{"\x6e\x61\x6d\x65"});(my ($sec,$microsec)=
Common::NXTime::getSecondsAndMicrosecondsSinceEpoch ());(my $milisec=sprintf (
"\x25\x30\x36\x64",$microsec));($milisec=substr ($milisec,(0x1248+ 2310-0x1b4e),
(0x1116+ 5328-0x25e3)));(my $startSeconds=$$NXProcess::childrenData{$pid}{
"\x73\x74\x61\x72\x74\x53\x65\x63\x6f\x6e\x64\x73"});(my $startMiliseconds=
$$NXProcess::childrenData{$pid}{
"\x73\x74\x61\x72\x74\x4d\x69\x6c\x69\x73\x65\x63\x6f\x6e\x64\x73"});(my $liveTimeSeconds
=($sec-$startSeconds));(my $liveTimeMiliseconds=($milisec-$startMiliseconds));if
 (($liveTimeMiliseconds<(0x1305+ 4226-0x2387))){($liveTimeMiliseconds=(
$liveTimeMiliseconds+(0x0ec1+ 383-0x0c58)));($liveTimeSeconds=($liveTimeSeconds-
(0x0bcc+ 4426-0x1d15)));}(my $liveTime=(($liveTimeSeconds."\x2c").sprintf (
"\x25\x30\x33\x64",$liveTimeMiliseconds)));return ($name,$liveTime);}return (
(""),(0x0695+ 2751-0x1154));}sub waitToTerminateOrKillIfStayAlive{(my $processPid
=shift (@_));(my $sleepTime=shift (@_));if (((not (defined ($processPid)))or (
$processPid<(0x09bb+ 532-0x0bcf)))){Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x61\x69\x74\x20\x74\x6f\x20\x74\x65\x72\x6d\x69\x6e\x61\x74\x65\x20\x6f\x72\x20\x6b\x69\x6c\x6c\x20\x69\x66\x20\x73\x74\x61\x79\x20\x61\x6c\x69\x76\x65\x20\x77\x69\x74\x68\x6f\x75\x74\x20\x50\x49\x44\x2e"
);return;}if (((not (defined ($sleepTime)))or ($sleepTime<(0x0028+ 2221-0x08d4))
)){($sleepTime=(0x07af+ 2185-0x1037));}if (isProcessRunning ($processPid)){
nxwaitpid ($processPid,$NXBits::WAIT_UNTRACED,$sleepTime);if (isProcessRunning (
$processPid)){if (sigkill ($processPid)){Logger::debug (((
"\x53\x49\x47\x4b\x49\x4c\x4c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));}else{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));}}}else{Logger::debug (((
"\x43\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$processPid).
"\x27\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x6f\x70\x70\x65\x64\x2e"
));}}sub waitToTerminateOrKillByScriptIfStayAlive{(my $processPid=shift (@_));(my $sleepTime
=shift (@_));if (((not (defined ($processPid)))or ($processPid<
(0x0349+ 7733-0x217e)))){Logger::warning (
"\x77\x61\x69\x74\x54\x6f\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x4f\x72\x4b\x69\x6c\x6c\x42\x79\x53\x63\x72\x69\x70\x74\x49\x66\x53\x74\x61\x79\x41\x6c\x69\x76\x65\x3a\x20\x70\x69\x64\x20\x6e\x6f\x74\x20\x70\x72\x6f\x76\x69\x64\x65\x64\x2e"
);return;}if (((not (defined ($sleepTime)))or ($sleepTime<(0x17c8+ 2795-0x22b2))
)){($sleepTime=(0x09c5+ 5684-0x1ff8));}if (isProcessRunning ($processPid)){(my $waitpid
=nxwaitpid ($processPid,$NXBits::WAIT_UNTRACED,$sleepTime));if (($waitpid!=
$processPid)){Logger::warning (((((
"\x77\x61\x69\x74\x54\x6f\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x4f\x72\x4b\x69\x6c\x6c\x42\x79\x53\x63\x72\x69\x70\x74\x49\x66\x53\x74\x61\x79\x41\x6c\x69\x76\x65\x3a\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid).
"\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x66\x69\x6e\x69\x73\x68\x20\x77\x69\x74\x68\x69\x6e\x20"
).$sleepTime).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e\x20\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x62\x79\x20\x72\x65\x73\x74\x72\x69\x63\x74\x65\x64\x20\x73\x63\x72\x69\x70\x74\x2e"
));signalProcessByRestrictedScript ($processPid,getSignalKill ());}}else{
Logger::debug (((
"\x77\x61\x69\x74\x54\x6f\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x4f\x72\x4b\x69\x6c\x6c\x42\x79\x53\x63\x72\x69\x70\x74\x49\x66\x53\x74\x61\x79\x41\x6c\x69\x76\x65\x3a\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid).
"\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x6f\x70\x70\x65\x64\x2e"
));}}sub addWatchdogAsSuperuserOnWindows{Logger::warning (
"\x46\x75\x6e\x63\x74\x69\x6f\x6e\x20\x61\x64\x64\x57\x61\x74\x63\x68\x64\x6f\x67\x41\x73\x53\x75\x70\x65\x72\x75\x73\x65\x72\x4f\x6e\x57\x69\x6e\x64\x6f\x77\x73\x20\x63\x61\x6e\x20\x6f\x6e\x6c\x79\x20\x62\x65\x20\x72\x75\x6e\x20\x6f\x6e\x20\x57\x69\x6e\x64\x6f\x77\x73\x20\x73\x79\x73\x74\x65\x6d\x2e"
);return ((-(0x1d45+ 1308-0x2260)));}sub addProcessToWatchdogAsSuperuserList{(my $pid
=shift (@_));(my $handle=shift (@_));($$NXProcess::watchDogAsSuperuser{$pid}=
$handle);delete ($$NXProcess::finishedWatchDogList{$pid});}sub 
handleWatchdogAsSuperuserSIGCHLD{foreach my $pid (keys (
%$NXProcess::watchDogAsSuperuser)){(my $handle=$$NXProcess::watchDogAsSuperuser{
$pid});Logger::debug3 (((((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x6e\x6f\x74\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27"
.$pid)."\x27\x20\x77\x69\x74\x68\x20\x68\x61\x6e\x64\x6c\x65\x20\x27").$handle).
"\x27\x2e"));if ((not (libnxh::NXProcessRunning ($pid)))){Logger::debug (((
"\x4e\x6f\x74\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27".
$pid)."\x27\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"));(my $callback
=$$NXProcess::childrenExitCallback{$pid});Logger::debug (((((
"\x45\x78\x65\x63\x75\x74\x69\x6e\x67\x20\x63\x61\x6c\x6c\x62\x61\x63\x6b\x20\x27"
.$callback)."\x27\x20\x66\x6f\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27").$pid
)."\x27\x2e"));delete ($$NXProcess::watchDogAsSuperuser{$pid});Logger::debug (((
"\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x68\x61\x6e\x64\x6c\x65\x20\x27".$handle).
"\x27\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x6c\x69\x73\x74\x2e"));(my $return
=libnxh::NXRemoveProcess ($handle));Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x52\x65\x6d\x6f\x76\x65\x50\x72\x6f\x63\x65\x73\x73\x28"
.$handle)."\x29\x20\x72\x65\x74\x75\x72\x6e\x65\x64\x20\x27").$return).
"\x27\x2e"));if (($return==(-(0x0bc7+ 3744-0x1a66)))){
Common::NXCore::reportErrorFromNXPL (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x68\x61\x6e\x64\x6c\x65\x20\x27"
.$handle).
"\x27\x20\x66\x72\x6f\x6d\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x6c\x69\x73\x74\x2e"
));}($$NXProcess::finishedWatchDogList{$pid}=(0x094f+ 5513-0x1ed7));if ((
$callback ne (""))){&{$callback;}($pid,(0x0a0c+ 4736-0x1c8c));}}}}sub 
setChildExitCode{(my $pid=shift (@_));(my $code=shift (@_));(
$$NXProcess::finishedChildren{$pid}=$code);}sub getChildExitCode{(my $pid=shift 
(@_));if ((not (processTerminatedBySignal ($pid)))){return (
$$NXProcess::finishedChildren{$pid});}return (undef);}sub setChildExitSignal{(my $pid
=shift (@_));(my $sig=shift (@_));($$NXProcess::finishedChildren{$pid}=$sig);(
$$NXProcess::childFinishedWithSignal{$pid}=(0x1698+ 3768-0x254f));}sub 
getChildExitSignal{(my $pid=shift (@_));if (processTerminatedBySignal ($pid)){
return ($$NXProcess::finishedChildren{$pid});}return (undef);}sub 
getChildrenOfProcess{(my $pid=shift (@_));(my $commandPath=
Common::NXShellCommands::getPath ("\x70\x73"));if (($commandPath eq 
$Common::NXShellCommands::pathNotFound)){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6c\x69\x73\x74\x20\x63\x68\x69\x6c\x64\x72\x65\x6e\x20\x6f\x66\x20\x27"
.$pid).
"\x27\x2e\x20\x50\x72\x6f\x67\x72\x61\x6d\x20\x27\x70\x73\x27\x20\x69\x73\x20\x6e\x6f\x74\x20\x70\x72\x65\x73\x65\x6e\x74\x20\x69\x6e\x20\x61\x20\x6b\x6e\x6f\x77\x6e\x20\x70\x61\x74\x68\x2e"
));return (());}(my (@command)=());(my (@options)=());push (@command,
$commandPath);push (@command,"\x2d\x2d\x70\x70\x69\x64",$pid);push (@command,
"\x2d\x6f");push (@command,"\x70\x69\x64\x3d");(my ($stderr,$stdout,$exitValue)=
main::nxRunCommand ((\@command),(\@options)));if (($exitValue!=
(0x08c9+ 6230-0x211f))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6c\x69\x73\x74\x20\x63\x68\x69\x6c\x64\x72\x65\x6e\x20\x6f\x66\x20\x27"
.$pid)."\x27\x2e"));return (());}($stdout=~ s/^\s+|\s+$//g );(my (@pids)=split ( /\s+/ ,
$stdout,(0x0434+ 284-0x0550)));return (@pids);}"\x3f\x3f\x3f";
